
-- JohnDeere6210RGPuma
-- Specialization for JohnDeere6210RGPuma mod
-- Date 20/12/2015
-- Copyright (C) puma [FBM]
-- Contact via PM @ http://forbidden-mods.phpbb8.de


JohnDeere6210RGPuma = {};

function JohnDeere6210RGPuma.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function JohnDeere6210RGPuma:load(xmlFile)
	self.frontLinkageBottomArmRotNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontLinkageBottomArm1#rotationNode"));
	setRotation(self.frontLinkageBottomArmRotNode1, math.rad(-85), math.rad(0), math.rad(0));
	self.frontLinkageBottomArmRotNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontLinkageBottomArm2#rotationNode"));
	setRotation(self.frontLinkageBottomArmRotNode2, math.rad(-85), math.rad(0), math.rad(0));
end;

function JohnDeere6210RGPuma:delete()
end;

function JohnDeere6210RGPuma:readStream(streamId, connection)
end;

function JohnDeere6210RGPuma:writeStream(streamId, connection)
end;

function JohnDeere6210RGPuma:mouseEvent(posX, posY, isDown, isUp, button)
end;

function JohnDeere6210RGPuma:keyEvent(unicode, sym, modifier, isDown)
end;

function JohnDeere6210RGPuma:update(dt)
end;

function JohnDeere6210RGPuma:updateTick(dt)
end;

function JohnDeere6210RGPuma:draw()
end;

function JohnDeere6210RGPuma:onLeave()
end;

function JohnDeere6210RGPuma:onEnter()
end;

function JohnDeere6210RGPuma:attachImplement(implement)
	local jointType = implement.object.attacherJoint.jointType;
	local jointIndex = implement.jointDescIndex;

	if jointType == Vehicle.JOINTTYPE_IMPLEMENT then
		if implement.object.needsLowering then
			self.implementCount = math.max(self.implementCount - 1, 0);
		end;
		if jointIndex == 2 then
			setRotation(self.frontLinkageBottomArmRotNode1, math.rad(0), math.rad(0), math.rad(0));
			setRotation(self.frontLinkageBottomArmRotNode2, math.rad(0), math.rad(0), math.rad(0));
		end;
	elseif jointType == Vehicle.JOINTTYPE_TRAILER then
		if jointIndex == 3 then
		end;
	elseif jointType == Vehicle.JOINTTYPE_TRAILERLOW then
		if jointIndex == 4 then
		end;
	end;

	self.updateJoint = true;
end;

function JohnDeere6210RGPuma:detachImplement(implementIndex)
	local implement = self.attachedImplements[implementIndex];
	local jointIndex = implement.jointDescIndex;

	if implement.object.attacherJoint.jointType == Vehicle.JOINTTYPE_IMPLEMENT then
		if implement.object.needsLowering then
			self.implementCount = self.implementCount + 1;
		end;
		if jointIndex == 2 then
			setRotation(self.frontLinkageBottomArmRotNode1, math.rad(-77), math.rad(-12.948), math.rad(-17.21));
			setRotation(self.frontLinkageBottomArmRotNode2, math.rad(-77), math.rad(12.948), math.rad(17.21));
		end;
	else
	end;
	
	self.updateJoint = true;
end;

function JohnDeere6210RGPuma:validateAttacherJoint(implement, jointDesc, dt)
    if self.updateJoint then
        self.updateJoint = false;
        return true;
    end;
    return false;
end;
